import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * In dieser Klasse sind die Bewegungsablufe (bzw. Bewegungsmglichkeiten) der Objekte beschrieben (bzw. definiert)
 */
public abstract class Beweglich extends Actor
{
 private static final double WALKING_SPEED = 5.0;
    /**
     * An dieser Stelle wir die Geschwindigkeit der Klasse "Beweglich" festgelegt. (Wie schnell sich der Elefant bewegt, wenn eine Pfeiltaste gedrckt wird
     */
    private int speed = 2;

    /**
     * Bilder des Elefanten, wie er nach links bzw. rechts schaut
     */
    private GreenfootImage imageLookingLeft;
    private GreenfootImage imageLookingRight;
    
    
    public Beweglich()
    {
        imageLookingRight = getImage();
        imageLookingLeft = new GreenfootImage(imageLookingRight);
        imageLookingLeft.mirrorHorizontally();
    }
    
   
        /**
     * Elefant schaut nach rechts
     */
    public void lookToTheRight()
    {
        setImage(imageLookingRight);
    }
    
    /**
     * Elefant schaut nach links
     */
    public void lookToTheLeft()
    {
        setImage(imageLookingLeft);
    }
    
    /**
     * Bewegt den Elefanten nach rechts.
     */
    public void moveRight()
    {
        setLocation(getX()+speed,getY());
    }
    
    /**
     * Bewegt den Elefanten nach links.
     */
    public void moveLeft()
    {
        setLocation(getX()-speed,getY());
    }
    
    /**
     * Bewegt den Elefanten nach oben.
     */
    public void moveUp()
    {
        setLocation(getX(),getY()-speed);
    }
    
    /**
     * Bewegt den Elefanten nach unten.
     */
    public void moveDown()
    {
        setLocation(getX(),getY()+speed);
    }
    
    
 
    public void setSpeed(int newSpeed)
    {
        int cappedSpeed = newSpeed;
        if (cappedSpeed > 10) 
        {
            cappedSpeed = 10;
        }
        if (cappedSpeed < 0)
        {
            cappedSpeed = 0;
        }
        speed = cappedSpeed;
    }
    
    

    /**
     *
     */ 
     
    public Sahara getWorld()
    {
        return (Sahara) super.getWorld();
    }
   /**
    * Hier wird beschrieben, wie sich die Maus in der Welt bewegt. 
    */
    public void bewegDich()
    {
       
        if (Greenfoot.getRandomNumber(100) > 90) {
            turn(Greenfoot.getRandomNumber(90)-45);
        }
        double angle = Math.toRadians( getRotation() );
        int x = (int) Math.round(getX() + Math.cos(angle) * WALKING_SPEED);
        int y = (int) Math.round(getY() + Math.sin(angle) * WALKING_SPEED);
        
        setLocation(x, y);
        
    }
    public void turn(int angle)
    {
        setRotation(getRotation() + angle);
 
    }
    /**
     * Wenn die Maus auf den Reltrand trifft dreht sie sich
     */
    public void schauNachWeltRand()
    {
        if (weltRand() ) 
        {
            turn(17);
        }
}
public boolean weltRand()
    {
        if(getX() < 20 || getX() > getWorld().getWidth() - 20)
            return true;
        if(getY() < 20 || getY() > getWorld().getHeight() - 20)
            return true;
        else
            return false;
    }
}
